﻿
---------
function BGDefender_OnLoad(self)
---------
    self:RegisterEvent("ADDON_LOADED")
    self:RegisterEvent("VARIABLES_LOADED")
    self:RegisterEvent("ZONE_CHANGED_NEW_AREA")
    BGDefender_Msg("BG Defender loaded (ver "..GetAddOnMetadata("BGDefender", "Version").."). Type /bgd help for more information.")
    SLASH_BGDefender1 = "/BGDefender"
    SLASH_BGDefender2 = "/bgd"
    SlashCmdList["BGDefender"] = function(msg)
        BGDefender_SlashCommandHandler(msg)
    end
end


---------
function BGDefender_SlashCommandHandler(msg)
---------
    msg = strlower(msg)
    if (msg == "") then
        BGDefender_Prefs.ShowUI = BGDefender_Toggle()
    elseif (msg == "show") then
        BGDefender_Prefs.ShowUI = BGDefender_Toggle(true)
    elseif (msg == "hide") then
        BGDefender_Prefs.ShowUI = BGDefender_Toggle(false)
    elseif (msg == "status") then
        BGDefender_ShowStatus()
    elseif (msg == "options") or (msg == "o") then
        BGDefender_Options_Open()
    else
        DEFAULT_CHAT_FRAME:AddMessage("BG Defender Version "..GetAddOnMetadata("BGDefender", "Version"), 1.0, 0.5, 0.0)
        DEFAULT_CHAT_FRAME:AddMessage("  /bgd options |cFFFFFFFF- to set announcement channel", 1.0, 0.5, 0.0)
        DEFAULT_CHAT_FRAME:AddMessage("  /bgd [show/hide] |cFFFFFFFF- show/hide window", 1.0, 0.5, 0.0)
        DEFAULT_CHAT_FRAME:AddMessage("  /bgd status |cFFFFFFFF- BGDefender status", 1.0, 0.5, 0.0)
        DEFAULT_CHAT_FRAME:AddMessage(" ", 1.0, 0.5, 0.0)
    end
end


---------
function BGDefender_OnEvent(frame, event, ...)
---------
    if ((event == "ZONE_CHANGED_NEW_AREA") or (event == "ADDON_LOADED")) then
        if not BGDefender_Prefs then
            BGDefender_Settings_Default()
        end 
        if(BGDefender_isInBG()) then            
           BGDefender_Prefs.ShowUI = BGDefender_Toggle(true)
       else
           BGDefender_Prefs.ShowUI = BGDefender_Toggle(false)
       end
    elseif (event == "VARIABLES_LOADED") then
        if not BGDefender_Prefs then
            BGDefender_Settings_Default()
        end 
        BGDefender_Options_Frame_Setup()
        BGDefender_Options_Frame_UpdateViews()
    end
end


---------
function BGDefender_NumCall(arg1)
---------
    local location = nil
    local call = ""

    if (not BGDefender_isInBG()) then
        BGDefender_Msg(BGD_OUT)
        return
    end
    
    location = GetSubZoneText()
    
    if (location ~= "") then
        if(arg1==6) then
            call = BGD_INCPLUS
        elseif(arg1==7) then
            call = BGD_HELP
        elseif(arg1==8) then
            call = BGD_SAFE
        else 
            call = BGD_INC
            call = string.gsub(call, "$num", arg1)
        end
        call = string.gsub(call, "$base", location)
        
        local channel = BGDefender_Prefs.BGChat
        if (BGDefender_isInRaidBG()) then
            channel = BGDefender_Prefs.RaidChat
        end
        if (channel == BGD_GENERAL) then
            local index, name = GetChannelName(BGD_GENERAL.." - "..GetZoneText())
            if (index~=0) then 
                SendChatMessage("BGDefender: "..call , "CHANNEL", nil, index)
            end
        else
            SendChatMessage("BGDefender: "..call, channel)
        end
    else
        BGDefender_Msg(BGD_AWAY)
    end
end


---------
function BGDefender_Msg(text)
---------
    if (text) then
        DEFAULT_CHAT_FRAME:AddMessage(text, 1, 0, 0)
        UIErrorsFrame:AddMessage(text, 1.0, 1.0, 0, 1, 10) 
    end
end


---------
function BGDefender_isInRaidBG()
---------
    local zone = GetZoneText()
    local found = false
    if ((zone == BGD_WG)) then
        found = true
    end
    return found
end


---------
function BGDefender_isInBG()
---------
    local zone = GetZoneText()
    local found = false
    if ((zone == BGD_AV) or (zone == BGD_AB) or (zone == BGD_WSG) or (zone == BGD_WSL) or (zone == BGD_SWH) or (zone == BGD_EOTS) or (zone == BGD_SOTA) or (zone == BGD_IOC)) then
        found = true
    elseif (BGDefender_isInRaidBG()) then
        found = true
    end
    return found
end


---------
function BGDefender_ShowStatus()
---------
    DEFAULT_CHAT_FRAME:AddMessage(" ", 1.0, 0.5, 0.0)
    DEFAULT_CHAT_FRAME:AddMessage("BG Defender Version |cFF00FF00"..GetAddOnMetadata("BGDefender", "Version").."|r Status", 1.0, 0.5, 0.0)
    
    if (BGDefender_Prefs.ShowUI == true) then
        DEFAULT_CHAT_FRAME:AddMessage("    UI Visible: |cFF00FF00Yes", 1.0, 0.5, 0.0)
    else
        DEFAULT_CHAT_FRAME:AddMessage("    UI Visible: |cFFFF0000No|r (/bgd to display)", 1.0, 0.5, 0.0)
    end
    DEFAULT_CHAT_FRAME:AddMessage("    Battleground Channel: |cFF00FF00"..BGDefender_Prefs.BGChat, 1.0, 0.5, 0.0)
    DEFAULT_CHAT_FRAME:AddMessage("    World Zone Channel: |cFF00FF00"..BGDefender_Prefs.RaidChat, 1.0, 0.5, 0.0)
    DEFAULT_CHAT_FRAME:AddMessage("    Zone: |cFF00FF00"..GetZoneText().."|r (|cFF00FF00"..GetSubZoneText().."|r)", 1.0, 0.5, 0.0)
    if (BGDefender_isInBG()) then
        DEFAULT_CHAT_FRAME:AddMessage("    BG zone? |cFF00FF00Yes", 1.0, 0.5, 0.0)
    else
        DEFAULT_CHAT_FRAME:AddMessage("    BG zone? |cFFFF0000No", 1.0, 0.5, 0.0)
    end
    DEFAULT_CHAT_FRAME:AddMessage("    Battleground Zones: ", 1.0, 0.5, 0.0)
    DEFAULT_CHAT_FRAME:AddMessage("        "..BGD_AV..", "..BGD_AB..",", 1.0, 1.0, 1.0)
    DEFAULT_CHAT_FRAME:AddMessage("        "..BGD_WSG..", "..BGD_EOTS..",", 1.0, 1.0, 1.0)
    DEFAULT_CHAT_FRAME:AddMessage("        "..BGD_SOTA..", "..BGD_IOC, 1.0, 1.0, 1.0)
    DEFAULT_CHAT_FRAME:AddMessage("    World PVP Zones: ", 1.0, 0.5, 0.0)
    DEFAULT_CHAT_FRAME:AddMessage("        "..BGD_WG, 1.0, 1.0, 1.0)
end


---------
function BGDefender_Toggle(state)
---------
    local frame  = getglobal("BGDefenderFrame")
    local status = nil
    if (frame) then
        if (state == false) then
            frame:Hide()
            status = false
        elseif (state == true) then
            frame:Show()
            status = true
        else
            if(frame:IsVisible()) then
                frame:Hide()
                status = false
            else
                frame:Show()
                status = true
            end
        end
        return status
    end
end


---------
function BGDefender_Close()
---------
    BGDefender_Prefs.ShowUI = BGDefender_Toggle(false)
end


---------
function BGDefender_Options_Open()
---------
    BGDefender_Prefs.BGChatTemp = BGDefender_Prefs.BGChat
    BGDefender_Prefs.RaidChatTemp = BGDefender_Prefs.RaidChat
    BGDefender_Options_Frame_UpdateViews()
    InterfaceOptionsFrame_OpenToCategory(BGDefender_Options_Frame)
end


---------
function BGDefender_Options_Frame_OnLoad(BGDefender_Options_Frame)
---------
    BGDefender_Options_Frame.name = "Battleground Defender"
    BGDefender_Options_Frame.okay = function (self) BGDefender_Options_Frame_Okay(); end
    BGDefender_Options_Frame.default = function (self) BGDefender_Settings_Default(); BGDefender_Options_Frame_UpdateViews(); end
    InterfaceOptions_AddCategory(BGDefender_Options_Frame)
end


---------
function BGDefender_Options_Frame_Okay()
---------
    BGDefender_Prefs.BGChat = BGDefender_Prefs.BGChatTemp
    BGDefender_Prefs.RaidChat = BGDefender_Prefs.RaidChatTemp
end


---------
function BGDefender_Settings_Default()
---------
    BGDefender_Prefs = {}
    BGDefender_Prefs.Title = GetAddOnMetadata("BGDefender", "Title")
    BGDefender_Prefs.RaidChat = "RAID"
    BGDefender_Prefs.RaidChatTemp = "RAID"
    BGDefender_Prefs.BGChat = "BATTLEGROUND"
    BGDefender_Prefs.BGChatTemp = "BATTLEGROUND"
    BGDefender_Prefs.version = GetAddOnMetadata("BGDefender", "Version")
    BGDefender_Prefs.ShowUI = BGDefender_isInBG()
end


BGDefender_Options_Title = nil
BGDefender_Options_Text1 = nil
BGDefender_Options_Text2 = nil
BGDefender_Options_Text3 = nil
BGDefender_Options_Text4 = nil
BGDefender_Options_DropDown1 = nil
BGDefender_Options_DropDown2 = nil

---------
function BGDefender_Options_Frame_Setup()
---------
    BGDefender_Options_Title = BGDefender_Options_Frame:CreateFontString( nil, "ARTWORK", "GameFontNormalLarge" )
    BGDefender_Options_Title:SetPoint( "TOPLEFT", 16, -16 )
    BGDefender_Options_Title:SetText( BGDefender_Prefs.Title )

    BGDefender_Options_Text1 = BGDefender_Options_Frame:CreateFontString( nil, "ARTWORK", "GameFontNormalSmall" )
    BGDefender_Options_Text1:SetPoint( "TOPLEFT", "BGDefender_Options_Title", "BOTTOMLEFT", 16, -16 )
    BGDefender_Options_Text1:SetText( "Battleground announcement channel: " )
    
    BGDefender_Options_DropDown1 = CreateFrame("Frame", "DropDown1", BGDefender_Options_Frame, "UIDropDownMenuTemplate");
    BGDefender_Options_DropDown1:SetPoint("TOPLEFT", "BGDefender_Options_Text1", "TOPRIGHT", 0, 8)
    UIDropDownMenu_Initialize(BGDefender_Options_DropDown1, BGDefender_Options_DropDown1_Initialize);
    
    BGDefender_Options_Text2 = BGDefender_Options_Frame:CreateFontString( nil, "ARTWORK", "GameFontNormalSmall" )
    BGDefender_Options_Text2:SetPoint( "TOPLEFT", "BGDefender_Options_Text1", "BOTTOMLEFT", 0, -32 )
    BGDefender_Options_Text2:SetText( "World Zone PVP announcement channel: " )
    
    BGDefender_Options_DropDown2 = CreateFrame("Frame", "DropDown2", BGDefender_Options_Frame, "UIDropDownMenuTemplate");
    BGDefender_Options_DropDown2:SetPoint("TOPLEFT", "DropDown1", "BOTTOMLEFT", 0, -10)
    UIDropDownMenu_Initialize(BGDefender_Options_DropDown2, BGDefender_Options_DropDown2_Initialize);
	
    BGDefender_Options_Text3 = BGDefender_Options_Frame:CreateFontString( nil, "ARTWORK", "GameFontNormalSmall" )
    BGDefender_Options_Text3:SetPoint( "TOPLEFT", 16, -128 )
    BGDefender_Options_Text3:SetText( "Be careful when using "..BGD_GENERAL.." chat because");
	BGDefender_Options_Text3:Hide()
	
	BGDefender_Options_Text4 = BGDefender_Options_Frame:CreateFontString( nil, "ARTWORK", "GameFontNormalSmall" )
    BGDefender_Options_Text4:SetPoint( "TOPLEFT", 16, -144 )
    BGDefender_Options_Text4:SetText( "Blizzard limits how fast you can post messages." )
	BGDefender_Options_Text4:Hide()
end



---------
function BGDefender_Options_DropDown1_Initialize()
---------
    local info = {}
    info = {}
    info.text = "Battleground"
    info.checked = (BGDefender_Prefs.BGChatTemp == "BATTLEGROUND")
    function info.func(arg1, arg2)
        BGDefender_Prefs.BGChatTemp = "BATTLEGROUND"
        BGDefender_Options_Frame_UpdateViews()
    end
    UIDropDownMenu_AddButton(info)
    
    info = {}
    info.text = "Raid"
    info.checked = (BGDefender_Prefs.BGChatTemp == "RAID")
    function info.func(arg1, arg2)
        BGDefender_Prefs.BGChatTemp = "RAID"
        BGDefender_Options_Frame_UpdateViews()
    end
    UIDropDownMenu_AddButton(info)
    
    info = {}
    info.text = "Party"
    info.checked = (BGDefender_Prefs.BGChatTemp == "PARTY")
    function info.func(arg1, arg2)
        BGDefender_Prefs.BGChatTemp = "PARTY"
        BGDefender_Options_Frame_UpdateViews()
    end
    UIDropDownMenu_AddButton(info)
    
    info = {}
    info.text = BGD_GENERAL
    info.checked = (BGDefender_Prefs.BGChatTemp == BGD_GENERAL)
    function info.func(arg1, arg2)
        BGDefender_Prefs.BGChatTemp = BGD_GENERAL
        BGDefender_Options_Frame_UpdateViews()
    end
    UIDropDownMenu_AddButton(info)

    info = {}
    info.text = "Yell"
    info.checked = (BGDefender_Prefs.BGChatTemp == "YELL")
    function info.func(arg1, arg2)
        BGDefender_Prefs.BGChatTemp = "YELL"
        BGDefender_Options_Frame_UpdateViews()
    end
    UIDropDownMenu_AddButton(info)
end


---------
function BGDefender_Options_DropDown2_Initialize()
---------
    local info = {}
    info = {}
    info.text = "Raid"
    info.checked = (BGDefender_Prefs.RaidChatTemp == "RAID")
    function info.func(arg1, arg2)
        BGDefender_Prefs.RaidChatTemp = "RAID"
        BGDefender_Options_Frame_UpdateViews()
    end
    UIDropDownMenu_AddButton(info)
    
    info = {}
    info.text = "Party"
    info.checked = (BGDefender_Prefs.RaidChatTemp == "PARTY")
    function info.func(arg1, arg2)
        BGDefender_Prefs.RaidChatTemp = "PARTY"
        BGDefender_Options_Frame_UpdateViews()
    end
    UIDropDownMenu_AddButton(info)
    
    info = {}
    info.text = BGD_GENERAL
    info.checked = (BGDefender_Prefs.RaidChatTemp == BGD_GENERAL)
    function info.func(arg1, arg2)
        BGDefender_Prefs.RaidChatTemp = BGD_GENERAL
        BGDefender_Options_Frame_UpdateViews()
    end
    UIDropDownMenu_AddButton(info)

    info = {}
    info.text = "Yell"
    info.checked = (BGDefender_Prefs.RaidChatTemp == "YELL")
    function info.func(arg1, arg2)
        BGDefender_Prefs.RaidChatTemp = "YELL"
        BGDefender_Options_Frame_UpdateViews()
    end
    UIDropDownMenu_AddButton(info)
end
 
---------
function BGDefender_Options_Frame_UpdateViews()
---------
	BGDefender_Options_Text3:Hide()
	BGDefender_Options_Text4:Hide()
    if (BGDefender_Prefs.BGChatTemp == "BATTLEGROUND") then
        UIDropDownMenu_SetText(BGDefender_Options_DropDown1, "Battleground")
    elseif (BGDefender_Prefs.BGChatTemp == "RAID") then
        UIDropDownMenu_SetText(BGDefender_Options_DropDown1, "Raid")
    elseif (BGDefender_Prefs.BGChatTemp == "PARTY") then
        UIDropDownMenu_SetText(BGDefender_Options_DropDown1, "Party")
    elseif (BGDefender_Prefs.BGChatTemp == BGD_GENERAL) then
		BGDefender_Options_Text3:Show()
		BGDefender_Options_Text4:Show()
        UIDropDownMenu_SetText(BGDefender_Options_DropDown1, BGD_GENERAL)
    elseif (BGDefender_Prefs.BGChatTemp == "YELL") then
        UIDropDownMenu_SetText(BGDefender_Options_DropDown1, "Yell")
    end
    
    if (BGDefender_Prefs.RaidChatTemp == "RAID") then
        UIDropDownMenu_SetText(BGDefender_Options_DropDown2, "Raid")
    elseif (BGDefender_Prefs.RaidChatTemp == "PARTY") then
        UIDropDownMenu_SetText(BGDefender_Options_DropDown2, "Party")
    elseif (BGDefender_Prefs.RaidChatTemp == BGD_GENERAL) then
		BGDefender_Options_Text3:Show()
		BGDefender_Options_Text4:Show()
        UIDropDownMenu_SetText(BGDefender_Options_DropDown2, BGD_GENERAL)
    elseif (BGDefender_Prefs.RaidChatTemp == "YELL") then
        UIDropDownMenu_SetText(BGDefender_Options_DropDown2, "Yell")
    end
end